//-----------------------------------------------------------------------------
// Object: menu interface
//-----------------------------------------------------------------------------

#pragma once

class IPluginMenu
{
public:
    virtual int STDMETHODCALLTYPE GetItemCount()=0;
    virtual UINT STDMETHODCALLTYPE AddMenuItem(TCHAR* Name,HICON hIcon)=0;
    virtual UINT STDMETHODCALLTYPE AddMenuItem(TCHAR* Name,HICON hIcon,UINT Index)=0; // returns item ID
    virtual UINT STDMETHODCALLTYPE AddSubMenuItem(TCHAR* SubMenuName,IPluginMenu* SubMenu,HICON hIcon)=0;// returns item ID
    virtual UINT STDMETHODCALLTYPE AddSubMenuItem(TCHAR* SubMenuName,IPluginMenu* SubMenu,HICON hIcon,UINT Index)=0;// returns item ID
    virtual UINT STDMETHODCALLTYPE AddSeparatorItem()=0;// returns item ID
    virtual UINT STDMETHODCALLTYPE AddSeparatorItem(UINT Index)=0;// returns item ID

    virtual void STDMETHODCALLTYPE SetCheckedState(UINT MenuID,BOOL bChecked)=0;
    virtual BOOL STDMETHODCALLTYPE IsChecked(UINT MenuID)=0;
    virtual void STDMETHODCALLTYPE SetEnabledState(UINT MenuID,BOOL bEnabled)=0;
    virtual BOOL STDMETHODCALLTYPE IsEnabled(UINT MenuID)=0;
    virtual BOOL STDMETHODCALLTYPE SetText(UINT MenuID,TCHAR* pszText)=0;
    virtual BOOL STDMETHODCALLTYPE SetIcon(UINT MenuID,HICON hIcon)=0;
    virtual void STDMETHODCALLTYPE Remove(UINT MenuID)=0;
};